Index: /trunk/language/uk_UA/admin.lang.php
===================================================================
--- /trunk/language/uk_UA/admin.lang.php	(revision 12776)
+++ /trunk/language/uk_UA/admin.lang.php	(revision 12777)
@@ -457,5 +457,4 @@
 $lang['Remove all filters'] = 'Видалити всі фільтри';
 $lang['remove author'] = 'видалити автора';
-$lang['Password confirmation error.'] = 'Помилка підтвердження пароля.';
 $lang['Password confirmation is missing. Please confirm the chosen password.'] = 'Відсутнє підтвердження пароля. Будь ласка, підтвердіть вибраний пароль.';
 $lang['Password is missing. Please enter the password.'] = 'Пароль відсутній. Будь ласка введіть пароль.';
@@ -587,4 +586,24 @@
 $lang['The anomaly will be ignored until next application version'] = 'Аномалію буде проігноровано до виходу наступної версії програми';
 $lang['The file or directory cannot be accessed (either it does not exist or the access is denied)'] = 'Файл або тека недоступні (або вони не існують або доступ заборонено)'; 
+$lang['%s has been successfully updated.'] = '%s було успішно оновлено.';
+$lang['%s photos can not be regenerated'] = '%s фотографії не можуть бути відновлені';
+$lang['%s photos have been regenerated'] = '%s фотографії були відновлені';
+$lang['%s thumbnails can not be regenerated'] = '%s ескізи не можуть бути відновлені';
+$lang['%s thumbnails have been regenerated'] = '%s ескізи були відновлені';
+$lang['(this tag will be deleted)'] = '(цей тег буде видалений)';
+$lang['... or '] = '... або ';
+$lang['Add to caddie'] = 'Додати в кедді';
+$lang['All extensions are up to date.'] = 'Всі розширення останніх версій.';
+$lang['All languages are up to date.'] = 'Всі мови останніх версій.';
+$lang['All plugins are up to date.'] = 'Всі плагінни останніх версій.';
+$lang['All themes are up to date.'] = 'Всі теми останніх версій.';
+$lang['Allowed file types: %s.'] = 'Дозволені типи файлів: %s.';
+$lang['An error has occured during extract. Please check files permissions of your piwigo installation.<br><a href="%s">Click here to show log error</a>.'] = 'Сталася помилка під час вилучення. Будь ласка, перевірте права доступу до файлів установки Piwigo.<br><a href="%s">Натисніть тут, щоб показати журнал помилок</a>.';
+$lang['An error has occured during upgrade.'] = 'Сталася помилка під час оновлення.';
+$lang['Approximate maximum resolution: %dM pixels (that\'s %dx%d pixels).'] = 'Приблизний максимальний дозвіл: %dM пікселів (це %dx%d пікселів).';
+$lang['By default, Piwigo will create a new websize from the HD (high definition) version of your photo.'] = 'За замовчуванням, Piwigo створить новий розмір від HD (високої чіткості) версії вашого фото.';
+$lang['Confirm merge'] = 'Підтвердіть злиття';
+$lang['Create'] = 'Створити';
+$lang['Crop'] = 'Результат';
 
 ?>
Index: /trunk/language/uk_UA/common.lang.php
===================================================================
--- /trunk/language/uk_UA/common.lang.php	(revision 12776)
+++ /trunk/language/uk_UA/common.lang.php	(revision 12777)
@@ -136,5 +136,4 @@
 $lang['About Piwigo'] = 'Про Piwigo';
 $lang['You are not authorized to access the requested page'] = 'Ви не авторизовані для доступу до запитуваної сторінки';
-$lang['Add to caddie'] = 'додати в кадді';
 $lang['add this photo to your favorites'] = 'Додати це фото в обране';
 $lang['Administration'] = 'Адміністрування';
@@ -363,4 +362,4 @@
 $lang['EXIF Metadata'] = 'EXIF метадані';
 $lang['IPTC Metadata'] = 'IPTC метадані';
-
+$lang['Edit'] = 'Редагувати';
 ?>