Index: trunk/language/fa_IR/common.lang.php
===================================================================
--- trunk/language/fa_IR/common.lang.php	(revision 12783)
+++ trunk/language/fa_IR/common.lang.php	(revision 12785)
@@ -32,6 +32,6 @@
 $lang_info['country'] = "ایران";
 $lang_info['direction'] = "rtl";
-$lang_info['code'] = "Per";
-$lang_info['zero_plural'] = "1";
+$lang_info['code'] = "fa";
+$lang_info['zero_plural'] = true;
 
 $lang['%d Kb'] = "%d Kb";
@@ -154,5 +154,5 @@
 $lang['created on %s'] = "ایجاد شده در %s";
 $lang['Customize'] = "سفارشی کردن";
-$lang['Your Gallery Customization'] = "گالری شما سفارشی شد";
+$lang['Your Gallery Customization'] = "سفارشی کردن گالری";
 $lang['day'][0] = "یک‌شنبه";
 $lang['day'][1] = "دوشنبه";
@@ -187,5 +187,5 @@
 $lang['in %d sub-albums'] = "در %d زیرآلبوم ";
 $lang['included'] = "پیوست شده";
-$lang['Invalid password!'] = "گذرواژه اشتباه است";
+$lang['Invalid password!'] = "گذرواژه نامعتبر است";
 $lang['Language'] = "زبان";
 $lang['last %d days'] = "%d روز گذشته";
@@ -253,6 +253,6 @@
 $lang['Kind of date'] = "گروه تاریخ";
 $lang['Search for words'] = "جستجو واژه ها";
-$lang['Search for all terms'] = "چستچو برای تمام قوانین";
-$lang['Empty query. No criteria has been entered.'] = "شما هیچ قانونی برای جستجو تأیین نکرده‌اید";
+$lang['Search for all terms'] = 'جستجو برای همه ی واژه ها';
+$lang['Empty query. No criteria has been entered.'] = "شما هیچ معیاری برای جستجو تأیین نکرده‌اید";
 $lang['Search results'] = "نتایج جستجو";
 $lang['Search in sub-albums'] = "جستجو در زیرآلبوم ها";
@@ -333,4 +333,33 @@
 $lang['This author removed the comment with id %d'] = 'این نویسنده ، دیدگاهی با شناسه %d را پاک کرده است.';
 $lang['html tags are not allowed in login'] = 'شما در فرم ورود مجاز به استفاده از كدهاي اچ تی ام ال نيستيد!';
+$lang['%d rates'] = '%d امتیاز';
+$lang['Change my password'] = 'ویرایش گذرواژه';
+$lang['Check your email for the confirmation link'] = 'برای مشاهده ی لینک تأیید ایمیل خود را چک کنید';
+$lang['Download this file'] = 'دانلود این فایل';
+$lang['Download'] = 'دانلود';
+$lang['Edit'] = 'ویرایش';
+$lang['Enter your new password below.'] = 'گذرواژه ی تازه ی خود را وارد کنید.';
+$lang['EXIF Metadata'] = 'EXIF Metadata';
+$lang['If this was a mistake, just ignore this email and nothing will happen.'] = 'اگر اشتباهی رخ داده است، این ایمیل را نا دیده بگیرید و به آن پاسخ ندهید.';
+$lang['Invalid key'] = 'کلید اشتباه است';
+$lang['Invalid username or email'] = 'نام کاربری یا ایمیل نامعتبر است';
+$lang['IPTC Metadata'] = 'IPTC Metadata';
+$lang['Number of photos per page'] = 'تعداد عکس ها در هر صفحه';
+$lang['Password reset is not allowed for this user'] = 'بازنشانی گذرواژه برای این کاربر ممکن نیست';
+$lang['Password Reset'] = 'بازنشانی گذرواژه';
+$lang['Please enter your username or email address.'] = 'نام کاربری یا ایمیل خود را وارد کنید.';
+$lang['Rating score'] = 'مقدار امتیاز';
+$lang['Return to home page'] = 'بازگشت به صفحه اصلی';
+$lang['Search by date'] = "جستجو با تاریخ";
+$lang['Search for any term'] = 'جستجو برای هر واژه ای';
+$lang['Someone requested that the password be reset for the following user account:'] = 'یک نفر برای این حساب کاربری درخواست بازنشانی گذرواژه کرده است:';
+$lang['The number of photos per page must be a not null scalar'] = 'تعداد عکس ها در هر صفحه باید یک عدد صحیح بجز 0 باشد';
+$lang['The passwords do not match'] = 'گذرواژه ها یکسان نمی باشند';
+$lang['To reset your password, visit the following address:'] = 'برای بازنشانی گذرواژتان، به آدرس زیر بروید:';
+$lang['User "%s" has no email address, password reset is not possible'] = 'حساب کاربری "%s" دارای ایمیل نمی باشد، بازنشانی گذرواژه امکان پذیر نیست';
+$lang['Username "%s" on gallery %s'] = 'نام کاربری "%s" در گالری %s';
+$lang['Username or email'] = 'نام کاربری یا ایمیل';
+$lang['You will receive a link to create a new password via email.'] = 'بزودی یک لینک برای ساخت گذرواژه ی تازه در ایمیلتان دریافت خواهید کرد.';
+$lang['Your password has been reset'] = 'گذرواژه ی شما با موفقیت بازنشانی شد';
 
 ?>