Index: trunk/language/sv_SE/admin.lang.php
===================================================================
--- trunk/language/sv_SE/admin.lang.php	(revision 12786)
+++ trunk/language/sv_SE/admin.lang.php	(revision 12787)
@@ -173,5 +173,4 @@
 $lang['You cannot move an album in its own sub album'] = 'Du kan inte flytta en kategori till sin egen underkategori';
 $lang['You need to confirm deletion'] = 'Du måste godkänna borttagning';
-$lang['add tags'] = 'lägg till taggar';
 $lang['Associate to album'] = 'associera till kategori';
 $lang['associate to group'] = 'associera till grupp';
@@ -411,5 +410,4 @@
 $lang['Toggle \'default group\' property'] = 'Omvänd egenskap för \'standard grupp\' ';
 $lang['Advanced features'] = 'Avancerade funktioner';
-$lang['Specials'] = 'Extra';
 $lang['Overall'] = 'Översikt';
 $lang['Year'] = 'År';
@@ -506,5 +504,4 @@
 $lang['Are you sure you want to install this plugin?'] = 'Är du säker på att du vill installera detta plugin?';
 $lang['Are you sure to install this upgrade? You must verify if this version does not need uninstallation.'] = 'Är du säker på att du vill installera uppdateringen? Du måste verifiera nedan att denna version inte behöver yterligare avinstallering.';
-$lang['%s has been successfully upgraded.'] = '%s har uppdaterats med framgång.';
 $lang['Plugin has been successfully copied'] = 'Kopiering av detta plugin utfördes med framgång';
 $lang['You might go to plugin list to install and activate it.'] = 'Gå till plugin listan för att installera och aktivera.';
@@ -569,5 +566,4 @@
 $lang['Password is missing. Please enter the password.'] = 'Lösenord saknas. Ange lösenord.';
 $lang['Password confirmation is missing. Please confirm the chosen password.'] = 'Bekräftelse av lösenord saknas. Vänligen bekräfta ditt valda lösenord.';
-$lang['Password confirmation error.'] = 'Fel uppstod när lösenord skulle bekräftas.';
 $lang['Allow users to edit their own comments'] = 'Tillåt användare att ändra egna kommentarer';
 $lang['Allow users to delete their own comments'] = 'Tillåt användare att ta bort egna kommentarer';
@@ -603,6 +599,4 @@
 $lang['Who can see these photos?'] = 'Vem kan se dessa foton?';
 $lang['Who can see this photo?'] = 'Vem kan se detta foto?';
-
-
 $lang['The websize maximum width must be a number between %d and %d'] = 'Webstorlekens maximala bredd måste vara ett nummer mellan %d och %d';
 $lang['The websize maximum height must be a number between %d and %d'] = 'Webstorlekens maximala höjd måste vara ett nummer mellan %d och %d';
@@ -726,7 +720,4 @@
 $lang['All %d photos are selected'] = 'Alla %d bilder väljs';
 $lang['remove this filter'] = 'Ta bort det här filtret';
-$lang['predefined filter'] = 'förinställt filter';
-$lang['last import'] = 'senaste import';
-$lang['with no virtual album'] = 'utan virtuellt album';
 $lang['Duplicates'] = 'dubbletter';
 $lang['Add a filter'] = 'Lägg till ett filter';
@@ -743,6 +734,4 @@
 $lang['Type here the title'] = 'Skriv rubriken här';
 $lang['remove creation date'] = 'Ta bort skapande datum ';
-$lang['with no album'] = 'utan album';
-$lang['with no tag'] = 'utan tagg';
 $lang['Album photos associated to the following albums: %s'] = 'Album bilder associerade till följande album: %s';
 $lang['Delete orphan tags'] = 'Ta bort anonyma taggar';
@@ -848,4 +837,13 @@
 $lang['Piwigo cannot retrieve upgrade file from server'] = 'Piwigo kan inte hämta uppgraderingen från servern';
 $lang['Zoom'] = 'förstora';
+$lang['Add to caddie'] = 'lägg i korgen';
+$lang['%s has been successfully updated.'] = '%s har uppdaterats.';
+$lang['Add tags'] = 'Lägg till taggar';
+$lang['High dimensions'] = 'Hög upplösning dimensioner';
+$lang['Last import'] = 'Senaste import';
+$lang['Predefined filter'] = 'Fördefinierat filter';
+$lang['With no album'] = 'Utan album';
+$lang['With no tag'] = 'Utan tag';
+$lang['With no virtual album'] = 'Utan virtuellt album';
 
 ?>
Index: trunk/language/sv_SE/common.lang.php
===================================================================
--- trunk/language/sv_SE/common.lang.php	(revision 12786)
+++ trunk/language/sv_SE/common.lang.php	(revision 12787)
@@ -157,5 +157,4 @@
 $lang['About Piwigo'] = 'Om Piwigo';
 $lang['You are not authorized to access the requested page'] = 'Du har inte behörighet till den begärda sidan';
-$lang['Add to caddie'] = 'lägg i korgen';
 $lang['add this photo to your favorites'] = 'lägg bilden i dina favoriter';
 $lang['Administration'] = 'Administration';
@@ -363,4 +362,5 @@
 $lang['EXIF Metadata'] = 'EXIF Metadata';
 $lang['IPTC Metadata'] = 'IPTC Metadata';
+$lang['Edit'] = 'Redigera';
 
 ?>