Index: trunk/language/cs_CZ/admin.lang.php
===================================================================
--- trunk/language/cs_CZ/admin.lang.php	(revision 12693)
+++ trunk/language/cs_CZ/admin.lang.php	(revision 12813)
@@ -176,5 +176,4 @@
 $lang['You cannot move an album in its own sub album'] = 'Nemůžete přesunout album do jeho vlastního sub alba';
 $lang['You need to confirm deletion'] = 'Je nutné potvrdit vymazání';
-$lang['add tags'] = 'Přidat klíčová slova';
 $lang['Associate to album'] = 'přiřadit k album';
 $lang['associate to group'] = 'Přiřadit ke skupině';
@@ -416,5 +415,4 @@
 $lang['Toggle \'default group\' property'] = 'Přepnout vlastnost \'základní skupina\'';
 $lang['Advanced features'] = 'Rozšířené vlastnosti';
-$lang['Specials'] = 'Ostatní';
 $lang['Overall'] = 'Celkově';
 $lang['Year'] = 'Rok';
@@ -426,5 +424,4 @@
 $lang['Element'] = 'Fotografie';
 $lang['Section'] = 'sekce';
-$lang['Tags'] = 'Klíčová slova';
 $lang['Save page visits by guests'] = 'Ukládat stránky navštívené hosty';
 $lang['Save page visits by users'] = 'Ukládat stránky navštívené uživateli';
@@ -509,9 +506,7 @@
 $lang['Other plugins'] = 'Další doplňky';
 $lang['Last revisions'] = 'Poslední revize';
-$lang['Delete'] = 'Vymazat';
 $lang['Are you sure you want to delete this plugin?'] = 'Přejete si odstranit tento doplněk?';
 $lang['Are you sure you want to install this plugin?'] = 'Přejete si nainstalovat tento doplněk?';
 $lang['Are you sure to install this upgrade? You must verify if this version does not need uninstallation.'] = 'Přejete si nainstalovat tuto aktualizaci? Je potřeba ověřit, jestli stávající verzi není nutné nejdříve odinstalovat.';
-$lang['%s has been successfully upgraded.'] = '%s byl úspěšně aktualizován.';
 $lang['Plugin has been successfully copied'] = 'Doplněk byl úspěšně nainstalován';
 $lang['You might go to plugin list to install and activate it.'] = 'Doplněk je potřeba aktivovat v seznamu doplňků.';
@@ -592,5 +587,4 @@
 $lang['Password is missing. Please enter the password.'] = 'Chybí heslo. Prosím napište heslo.';
 $lang['Password confirmation is missing. Please confirm the chosen password.'] = 'Chybí potvrzení hesla. Prosím potvrďte vybrané heslo.';
-$lang['Password confirmation error.'] = 'Chyba při potvrzení hesla.';
 $lang['Allow users to edit their own comments'] = 'Povolit uzivatelům upravovat jejich vlastní komentáře';
 $lang['Allow users to delete their own comments'] = 'Povolit uzivatelům mazat jejich vlastní komentáře';
@@ -734,7 +728,4 @@
 $lang['All %d photos are selected'] = 'Všech %d fotografií bylo vybráno';
 $lang['remove this filter'] = 'smazat tento filtr';
-$lang['predefined filter'] = 'předdefinovaný filtr';
-$lang['last import'] = 'poslední import';
-$lang['with no virtual album'] = 'bez virtuálního alba';
 $lang['Duplicates'] = 'duplikáty';
 $lang['Add a filter'] = 'Přidat filtr';
@@ -751,6 +742,4 @@
 $lang['Type here the title'] = 'Napište zde název';
 $lang['remove creation date'] = 'smazat datum vytvoření';
-$lang['with no album'] = 'bez alba';
-$lang['with no tag'] = 'bez klíčového slova';
 $lang['Album photos associated to the following albums: %s'] = 'Fotky alba přiřazeny k následujícím albům: %s';
 $lang['Delete orphan tags'] = 'Smazat tagy';
@@ -856,4 +845,14 @@
 $lang['If no HD is available and if the current websize is bigger than resize dimensions, Piwigo will move it as HD and create a downsized websize photo from it.'] = 'Pokud nemáte obrázek v HD rozlišení a pokud stávající webové rozlišení je větší než nastavené rozsahy dimenzí obrázku, Piwigo fotku vezme jako HD a vytvoří zmenšenou verzi obrázku pro web z originálu.';
 $lang['Zoom'] = 'Přiblížit';
+$lang['Add to caddie'] = 'Přidat do košíku';
+$lang['%s has been successfully updated.'] = '%s: úspěšně aktualizováno.';
+$lang['Add tags'] = 'Přidat tagy';
+$lang['High dimensions'] = 'Rozměry velkého rozlišení';
+$lang['Last import'] = 'Poslední import';
+$lang['Photo name'] = 'Název fotografie';
+$lang['Predefined filter'] = 'Předdefinovaný filtr';
+$lang['With no album'] = 'Bez alba';
+$lang['With no tag'] = 'Bez tagu';
+$lang['With no virtual album'] = 'Bez virtuálního alba';
 
 ?>