Index: trunk/language/ar_SA/admin.lang.php
===================================================================
--- trunk/language/ar_SA/admin.lang.php	(revision 12813)
+++ trunk/language/ar_SA/admin.lang.php	(revision 12816)
@@ -173,5 +173,4 @@
 $lang['You cannot move an album in its own sub album'] = 'لايمكن حذف ألبوم يحتوي على ألبوم فرعي';
 $lang['You need to confirm deletion'] = 'تحتاج  تأكيد الحذف';
-$lang['add tags'] = 'اضافةكلمة دلائلية';
 $lang['Associate to album'] = 'المرتبط بهذا الألبوم';
 $lang['associate to group'] = 'مرتبط بهذه المجموعه';
@@ -399,6 +398,5 @@
 $lang['even already synchronized photos'] = 'سبق التزامن مع الصور';
 $lang['Used metadata'] = 'معومات التفصيلة مُـستخدمة';
-$lang['The name of directories and files must be composed of letters, numbers, "-", "_" or "."'] = '	
-اسم الأدلة والملفات يجب أن تكون مكونة من الحروف والأرقام ، "--" ، "_" أو "."';
+$lang['The name of directories and files must be composed of letters, numbers, "-", "_" or "."'] = 'اسم الأدلة والملفات يجب أن تكون مكونة من الحروف والأرقام ، "--" ، "_" أو "."';
 $lang['wrong filename'] = 'خطأ فادح  في اسم الملف';
 $lang['Upload'] = 'تحميل';
@@ -415,5 +413,4 @@
 $lang['Toggle \'default group\' property'] = 'ترجيح \'مجموعة افتراضية\' الخصوصية';
 $lang['Advanced features'] = 'مميزات متقدمة';
-$lang['Specials'] = 'خــاص';
 $lang['Overall'] = 'اجماليا';
 $lang['Year'] = 'سنة';
@@ -425,5 +422,4 @@
 $lang['Element'] = 'عنصر';
 $lang['Section'] = 'القسم';
-$lang['Tags'] = 'كلمات دلائلية';
 $lang['Save page visits by guests'] = 'حفظ الصفحات المشاهده من قبل الضيوف';
 $lang['Save page visits by users'] = 'حفظ الصفحة المشاهدة من قبل المستخدمين';
@@ -508,9 +504,7 @@
 $lang['Other plugins'] = 'اضافات أخرى';
 $lang['Last revisions'] = 'الاصدارت الاخيرة';
-$lang['Delete'] = 'حذف';
 $lang['Are you sure you want to delete this plugin?'] = 'هل انت متأكد من حذف هذه الاضاة?';
 $lang['Are you sure you want to install this plugin?'] = 'هل تريد فعلا تثبيت هذه الاضافة?';
 $lang['Are you sure to install this upgrade? You must verify if this version does not need uninstallation.'] = 'هل فعلا تريد ترقية هذا التحديث ؟ قد تحتاج ان تتأكد انك لن تحتاج لعلمية الغاء التنصيب.';
-$lang['%s has been successfully upgraded.'] = ' بنجاح %s تمت علميت التحديث .';
 $lang['Plugin has been successfully copied'] = 'تم نسخ الاضافة الجديدة بنجاح';
 $lang['You might go to plugin list to install and activate it.'] = 'ينبقي عليك تفعيلها من قائمة الاضافات.';
@@ -578,5 +572,4 @@
 $lang['Password is missing. Please enter the password.'] = 'لم تكتب كلمة المرور، فضلا ً أكتب كلمة المرور';
 $lang['Password confirmation is missing. Please confirm the chosen password.'] = 'لم يتم تأكيد كلمة المرور، فضلا ً لا أمر أكد المرور رحم الله والديك';
-$lang['Password confirmation error.'] = 'خطأ في تأكيد كلمة المرور';
 $lang['Allow users to edit their own comments'] = 'اسمح للمستخدم بتحريرتعليقه الخاص';
 $lang['Allow users to delete their own comments'] = 'اسمح للمستخدم بحذف تعليقه الخاص';
@@ -729,7 +722,4 @@
 $lang['All %d photos are selected'] = 'كل %d الصور المختارة ';
 $lang['remove this filter'] = 'ازل هذه المرشح';
-$lang['predefined filter'] = 'مُرشح مُسبق';
-$lang['last import'] = 'آخر استيراد';
-$lang['with no virtual album'] = 'مع عدم وجود ألبوم ظاهري';
 $lang['Duplicates'] = 'المكرر';
 $lang['Add a filter'] = 'أضف مُـرشح';
@@ -746,6 +736,4 @@
 $lang['Type here the title'] = 'أكتب هنا عنوان ';
 $lang['remove creation date'] = 'احذف تاريخ الانشاء';
-$lang['with no album'] = 'مع عدم وجود الألبوم';
-$lang['with no tag'] = 'مع عدم وجود كلمات دلائلية';
 $lang['Album photos associated to the following albums: %s'] = 'صور الالبوم المرتبطة بالابومات اللاحقة : %s';
 $lang['Delete orphan tags'] = 'جذف الاكواد اليتيمة';
Index: trunk/language/ar_SA/common.lang.php
===================================================================
--- trunk/language/ar_SA/common.lang.php	(revision 12813)
+++ trunk/language/ar_SA/common.lang.php	(revision 12816)
@@ -134,5 +134,4 @@
 $lang['Best rated'] = 'افضل تصويت';
 $lang['display best rated photos'] = 'اعرض الصور الاكثر تقيما من قبل المشاهدين';
-$lang['caddie'] = 'السلة';
 $lang['Calendar'] = 'التقويم';
 $lang['All'] = 'الجميع';
@@ -344,4 +343,30 @@
 $lang['This author removed the comment with id %d'] = 'هذا الكاتب أزال تعليقه : %d';
 $lang['html tags are not allowed in login'] = 'اكواد html غير مسموحة في تسجيل الدخول';
+$lang['%d rates'] = '%d التقييم';
+$lang['Change my password'] = 'غيّر كلمة المرور';
+$lang['Check your email for the confirmation link'] = 'تم ارسال رابط التأكيد الى بريدك الالكتروني ..افحص بريدك';
+$lang['Delete'] = 'مسح';
+$lang['Edit'] = 'تحرير';
+$lang['Enter your new password below.'] = 'ادخل كلمة المرور الجديدة .';
+$lang['EXIF Metadata'] = 'البيانات الوصفية EXIF';
+$lang['If this was a mistake, just ignore this email and nothing will happen.'] = 'اذا وصلتك هذه الرسالة عن طريق الخطأ فقط تجاهل هذه الرسالة  و لا شيء سوف يحدث ';
+$lang['Invalid key'] = 'مفتاح خاطئ';
+$lang['Invalid username or email'] = 'اسم المستخدم او البريد الالكتروني غير صحيح ';
+$lang['IPTC Metadata'] = 'IPTC البيانات الوصفية ';
+$lang['Number of photos per page'] = 'عدد الصور في كل صفحة';
+$lang['Password reset is not allowed for this user'] = 'لا يمكن تغير كلمة المرور لهذا المستخدم';
+$lang['Password Reset'] = 'اعادة تعين كلمة المرور ';
+$lang['Please enter your username or email address.'] = 'فضلاً ادخل اسم المستخدم او بريدك الالكتروني ';
+$lang['Rating score'] = 'حسب معدل التقييم';
+$lang['Return to home page'] = 'العودة للصفحة الرئيسية للمعرض';
+$lang['Someone requested that the password be reset for the following user account:'] = 'احدهم طلب اعادة تعين كلمة المرور للحساب : ';
+$lang['The number of photos per page must be a not null scalar'] = 'عدد الصور في كل صفحة لا يمكن ان يكون صفر';
+$lang['The passwords do not match'] = 'كلمة المرور لا تتطابق ';
+$lang['To reset your password, visit the following address:'] = 'لإعادة تعين كلمة المرور تفضل بزيارة العنوان التالي :';
+$lang['User "%s" has no email address, password reset is not possible'] = 'ليس للمستخدم "%s" بريد الكتروني .. لا يمكن اعادة تعين كامة المرور ';
+$lang['Username "%s" on gallery %s'] = 'اسم المستخدم "%s"  في  معرض %s ';
+$lang['Username or email'] = 'اسم المستخدم او البريد الالكتروني ';
+$lang['You will receive a link to create a new password via email.'] = 'ستصل الى بريدك رسالة برابط انشاء كلمة مرور جديدة ';
+$lang['Your password has been reset'] = ' تم اعادة تعيين كلمة المرور بنجاج ';
 
 ?>