Index: /trunk/language/hr_HR/admin.lang.php
===================================================================
--- /trunk/language/hr_HR/admin.lang.php	(revision 12816)
+++ /trunk/language/hr_HR/admin.lang.php	(revision 12817)
@@ -172,5 +172,4 @@
 $lang['You cannot move an album in its own sub album'] = 'Ne možete premjestiti skupinu u njenu vlastitu podskupinu';
 $lang['You need to confirm deletion'] = 'trebate potvrditi brisanje';
-$lang['add tags'] = 'dodaj tagove';
 $lang['Associate to album'] = 'poveži sa skupinom';
 $lang['associate to group'] = 'poveži sa grupom';
@@ -418,5 +417,4 @@
 $lang['Element'] = 'Stavka';
 $lang['Section'] = 'Odjeljak';
-$lang['Tags'] = 'Tagovi';
 $lang['Save page visits by guests'] = 'Pohrani posjete stranicama po gostima';
 $lang['Save page visits by users'] = 'Pohrani posjete stranicama po korisnicima';
@@ -444,5 +442,4 @@
 $lang['default values'] = 'pretpostavljene vrijednosti';
 $lang['High filesize'] = 'Visoka veličina zapisa';
-// --------- Starting below: New or revised $lang ---- from version 1.7.1
 $lang['Guest cannot be deleted'] = 'Gost ne može biti izbrisan';
 $lang['Default user cannot be deleted'] = 'Pretpostavljeni korisnik ne može biti izbrisan';
@@ -475,5 +472,4 @@
 $lang['Status of user "%s" updated'] = 'Stanje korisnika "%s" obnovljeno';
 $lang['add new photos to caddie'] = 'dodaj nove stavke u ladicu';
-// --------- Starting below: New or revised $lang ---- from Butterfly
 $lang['No display'] = 'Bez prikaza';
 $lang['Classic display'] = 'Klasični prikaz';
@@ -503,9 +499,7 @@
 $lang['Other plugins'] = 'Ostali dodaci';
 $lang['Last revisions'] = 'Zadnja izdanja';
-$lang['Delete'] = 'Izbriši';
 $lang['Are you sure you want to delete this plugin?'] = 'Sigurno želite ukloniti ovaj dodatak?';
 $lang['Are you sure you want to install this plugin?'] = 'Sigurno želite ugraditi ovaj dodatak?';
 $lang['Are you sure to install this upgrade? You must verify if this version does not need uninstallation.'] = 'Sigurno želite ugraditi ovaj dodatak? Morate ovjeriti ako ova inačica ne treba uklanjanje.';
-$lang['%s has been successfully upgraded.'] = '%s je uspješno obnovljen.';
 $lang['Plugin has been successfully copied'] = 'Dodatak je uspješno preslikan';
 $lang['You might go to plugin list to install and activate it.'] = 'Možete ići na popis dodataka za ugradbu i pokretanje.';
@@ -561,5 +555,4 @@
 $lang['Released on'] = 'Objavljeno dana';
 $lang['Number of downloads'] = 'Broj preuzimanja';
-// --------- Starting below: New or revised $lang ---- from Colibri
 $lang['Piwigo Announcements Newsletter'] = 'Piwigo Announcements e-Novine';
 $lang['Keep in touch with Piwigo project, subscribe to Piwigo Announcement Newsletter. You will receive emails when a new release is available (sometimes including a security bug fix, it\'s important to know and upgrade) and when major events happen to the project. Only a few emails a year.'] = 'Ostanite u vezi sa projektom, pretplatite se na Piwigo Announcement e-Novine. Primati ćete e-mail poruke po izlasku novih inačica (ponekad sa sigurnosnim zakrpama, važno je znati da su dostupne i treba ih što prije ugraditi) te o svim važnijim zbivanjima i događanjima u vezi sa projektom. Svega par e-mail poruka godišnje.';
@@ -568,10 +561,8 @@
 $lang['Purge search history'] = 'Pročisti povijest pretraživanja';
 $lang['Hide'] = 'Sakrij';
-// piwigo 2.1
 $lang['Operation in progress'] = 'Obrada postupka.';
 $lang['Please wait...'] = 'Sačekajte molim...';
 $lang['Password is missing. Please enter the password.'] = 'Nedostaje zaporka. Molimo unesite zaporku.';
 $lang['Password confirmation is missing. Please confirm the chosen password.'] = 'Nedostaje potvrda zaporke. Molimo potvrdite odabranu zaporku.';
-$lang['Password confirmation error.'] = 'Greška potvrde zaporke.';
 $lang['Allow users to edit their own comments'] = 'Dozvoliti korisnicima uređivanje vlastitih komentara';
 $lang['Allow users to delete their own comments'] = 'Dozvoliti korisnicima brisanje vlastitih komentara';
@@ -715,5 +706,4 @@
 $lang['include child albums'] = 'uključi podalbume';
 $lang['Keep high definition'] = 'Zadrži visoku kvalitetu';
-$lang['last import'] = 'zadnji import';
 $lang['manual order'] = 'ručni poredak';
 $lang['%d of %d photos selected'] = 'označeno %d od %d fotografija';
@@ -728,5 +718,4 @@
 $lang['Orphan tags deleted'] = 'Nekorištene oznake su izbrisane';
 $lang['Pending Comments'] = 'Neriješeni komentari';
-$lang['predefined filter'] = 'predefinirani filter';
 $lang['Refresh photo set'] = 'Osvježi grupu fotografija';
 $lang['Remove all filters'] = 'Ukloni sve filtre';
@@ -777,4 +766,24 @@
 $lang['Type in a search term'] = 'Traži ..';
 $lang['Unknown upload error'] = 'Nepoznata greška prilikom slanja datoteke';
+$lang['Add to caddie'] = 'dodaj u ladicu';
+$lang['%s has been successfully updated.'] = '%s je uspješno ažurirano.';
+$lang['%s photos can not be regenerated'] = '%s fotografija nije moguće regenerirati';
+$lang['%s photos have been regenerated'] = '%s fotografija regenerirano';
+$lang['%s thumbnails can not be regenerated'] = '%s malih sličica nije moguće regenerirati';
+$lang['%s thumbnails have been regenerated'] = '%s malih sličica je generirano';
+$lang['(this tag will be deleted)'] = '(ova oznaka je izbrisana)';
+$lang['... or '] = '... ili ';
+$lang['Add tags'] = 'Dodaj oznake';
+$lang['All extensions are up to date.'] = 'Svi dodaci su "up-to-date".';
+$lang['All languages are up to date.'] = 'Svi jezici su "up-to-date".';
+$lang['All plugins are up to date.'] = 'Svi plugin-ovi su "up-to-date".';
+$lang['All themes are up to date.'] = 'Sve teme su "up-to-date".';
+$lang['Allowed file types: %s.'] = 'Dozvoljeni tipovi datoteka: %s.';
+$lang['Approximate maximum resolution: %dM pixels (that\'s %dx%d pixels).'] = 'Približna maksimalna rezolucija: %dM px (to je %dx%d px).';
+$lang['By default, Piwigo will create a new websize from the HD (high definition) version of your photo.'] = 'Prema zadanim vrijednostima, Piwino će kreirati nove veličine od vaših originalnih verzija fotografija..';
+$lang['Confirm merge'] = 'Potvrdi spajanje';
+$lang['Create'] = 'Kreiraj';
+$lang['Crop'] = 'Izreži';
+$lang['display'] = 'prikaz';
 
 ?>
Index: /trunk/language/hr_HR/common.lang.php
===================================================================
--- /trunk/language/hr_HR/common.lang.php	(revision 12816)
+++ /trunk/language/hr_HR/common.lang.php	(revision 12817)
@@ -122,5 +122,4 @@
 $lang['About Piwigo'] = 'O Piwigo-u';
 $lang['You are not authorized to access the requested page'] = 'Niste ovlašteni za pristup zatraženoj stranici';
-$lang['Add to caddie'] = 'dodaj u ladicu';
 $lang['add this photo to your favorites'] = 'dodaj ovu sliku u omiljene';
 $lang['Administration'] = 'Uprava';
@@ -363,4 +362,5 @@
 $lang['EXIF Metadata'] = 'EXIF metapodaci';
 $lang['IPTC Metadata'] = 'IPTC metapodaci';
+$lang['Edit'] = 'Uredi';
 
 ?>