Index: /trunk/language/tr_TR/admin.lang.php
===================================================================
--- /trunk/language/tr_TR/admin.lang.php	(revision 12833)
+++ /trunk/language/tr_TR/admin.lang.php	(revision 12834)
@@ -449,4 +449,6 @@
 $lang['Members'] = 'Üyeler';
 $lang['Menu Management'] = 'Menü Yönetimi';
+$lang['Merge selected tags'] = 'Seçilen etiketleri birleştir';
+$lang['Merge tags'] = 'etiketleri birleştir';
 $lang['Metadata synchronization results'] = 'Metadata senkronizasyon sonuçları';
 $lang['Metadata synchronized from file'] = 'Metadata dosyadan senkronize edildi';
@@ -534,4 +536,5 @@
 $lang['Photo Page'] = 'Resim Sayfası';
 $lang['Photo Properties'] = 'Resim özellikleri';
+$lang['Photo name'] = 'Resim adı';
 $lang['Photo unreachable or no support'] = 'Resim erisilemiyor veya desteklenmeyen format';
 $lang['photos added in the database'] = 'elemanlar veritabanında ekledi';
@@ -546,4 +549,5 @@
 $lang['Piwigo Administration'] = 'Piwigo Yönetim';
 $lang['Piwigo Announcements Newsletter'] = 'Piwigo Duyuru Bülteni';
+$lang['Piwigo cannot retrieve upgrade file from server'] = 'Piwigo sunucudan yükseltme dosyasını alamıyor';
 $lang['Piwigo configuration'] = 'Piwigo yapılandırma';
 $lang['Piwigo Update'] = 'Piwigo Güncellemesi';
@@ -560,5 +564,5 @@
 $lang['Plugins'] = 'Eklentiler';
 $lang['Position'] = 'Pozisyon';
-$lang['predefined filter'] = 'filtre önceden tanımlanmış';
+$lang['Predefined filter'] = 'önceden tanımlanmış filtre';
 $lang['Preferences'] = 'Tercihler';
 $lang['Prepared time for list of users to send mail is limited. Others users are not listed.'] = 'Zamanli posta gönderilecek kullanıcılar listesi. Diger kullanıcılar listelenmez.';
@@ -634,6 +638,8 @@
 $lang['Select at least one photo'] = 'En az bir resim seçiniz';
 $lang['Select at least one user'] = 'En az bir kullanıcı seçiniz';
+$lang['Select at least two tags for merging'] = 'Birleştirmek için en az iki etiketleri seçin';
 $lang['Select files'] = 'Dosyaları seçin';
 $lang['Select recipients'] = 'Alicilari seç';
+$lang['Select the destination tag'] = 'Hedef etiketi seçin';
 $lang['Select:'] = 'Seç:';
 $lang['Selection'] = 'Seçim';
@@ -686,4 +692,5 @@
 $lang['Tag "%s" was added'] = 'Etiket "%s" eklendi';
 $lang['Tag selection'] = 'Etiket seçme';
+$lang['Tags <em>%s</em> merged into tag <em>%s</em>'] = 'Etiketler <em>%s</em> ile <em>%s</em> etiketleri birleştirildi';
 $lang['target'] = 'Hedef';
 $lang['Templates configuration has been recorded.'] = 'Şablonları yapılandırma kaydedildi.';
@@ -819,15 +826,19 @@
 $lang['Width'] = 'Genişlik';
 $lang['With blank value, gallery title will be used'] = 'Bos olursa, galeri baslik kullanilir';
-$lang['with no album'] = 'sıfır albüm ile';
-$lang['with no tag'] = 'sıfır etiket ile';
-$lang['with no virtual album'] = 'sıfır sanal albüm ile';
+$lang['With no album'] = 'sıfır albüm ile';
+$lang['With no tag'] = 'sıfır etiket ile';
+$lang['With no virtual album'] = 'sıfır sanal albüm ile';
 $lang['wrong filename'] = 'yanlış dosya';
 $lang['Year'] = 'Yıl';
 $lang['You are running on development sources, no check possible.'] = 'Gelistirme kaynaklarini kullaniyorsunuz incelemek mümkün degil';
 $lang['You are running the latest version of Piwigo.'] = 'Piwigo son sürümünü çalıştırıyorsunuz.';
+$lang['You are using the Browser uploader. Try the <a href="%s">Flash uploader</a> instead.'] = 'Tarayıcı yükleyiciyi kullanıyorsunuz. <a href="%s">Flash Yükleyiciyi</a> deneyiniz.';
+$lang['You are using the Flash uploader. Problems? Try the <a href="%s">Browser uploader</a> instead.'] = 'Flash Yükleyiciyi kullanıyorsunuz. Sorun mu var? <a href="%s">Tarayıcı Yükleyiciyi</a> deneyiniz.';
 $lang['You can update to Piwigo %s directly, without upgrading to Piwigo %s (recommended).'] = 'Piwigoyu direkt olarak %s\'e güncelleyebilirsiniz, Piwigo %s\'e güncellemeden (önerilir).';
 $lang['You cannot delete your account'] = 'Kendi hesabinizi silemezsiniz';
 $lang['You cannot move an album in its own sub album'] = 'Bir albümü kendi alt bölümü içindeki albüme taşıyamazsınız';
+$lang['You can\'t define a default photo order because you have a custom setting in your local configuration.'] = 'Varsayılan resim sırasını tanımlayamazsınız, çünkü yerel yapılandırmada özel bir ayar var';
 $lang['You have %d orphan tags: %s.'] = '%d etkisiz etiketleriniz: %s.';
+$lang['You have specified <i>$conf[\'order_by\']</i> in your local configuration file, this parameter in deprecated, please remove it or rename it into <i>$conf[\'order_by_custom\']</i> !'] = 'Yerel yapılandırma dosyasında <i>$conf[\'order_by\']</i> belirttiniz, bu parametre olarak önerilmemektedir, lütfen bu parametreyi siliniz veya <i>$conf[\'order_by_custom\']</i> olarak yeniden adlandırınız!';
 $lang['You have subscribed to receiving notifications by mail.'] = 'Posta yoluyla bildirimleri almak için abone oldunuz.';
 $lang['You have unsubscribed from receiving notifications by mail.'] = 'Posta yoluyla bildirimleri almak için olan aboneliginizi iptal ettiniz.';