Index: extensions/user_tags/language/tr_TR/description.txt
===================================================================
--- extensions/user_tags/language/tr_TR/description.txt	(revision 12837)
+++ extensions/user_tags/language/tr_TR/description.txt	(revision 12837)
@@ -0,0 +1,1 @@
+Ziyaretçilerin resimlere etiket eklemesi için izin verir
Index: extensions/user_tags/language/tr_TR/help/index.php
===================================================================
--- extensions/user_tags/language/tr_TR/help/index.php	(revision 12837)
+++ extensions/user_tags/language/tr_TR/help/index.php	(revision 12837)
@@ -0,0 +1,28 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | User Tags  - a plugin for Piwigo                                      |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA.                                                    |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
Index: extensions/user_tags/language/tr_TR/help/readme.html
===================================================================
--- extensions/user_tags/language/tr_TR/help/readme.html	(revision 12837)
+++ extensions/user_tags/language/tr_TR/help/readme.html	(revision 12837)
@@ -0,0 +1,8 @@
+<h2>Dokümantasyon</h2>
+
+<h3>Kullanım</h3>
+<p>Bir kullanıcı "ekle" iznine sahip ise ve etiketler resim sayfasında gösteriliyor ise, kullanıcı bu etiketleri "düzenle" simgesine tıklayarak değiştirebilir.</p>
+
+<h3>İzinler</h3>
+<p>İzinler kullanıcıların durumuna bağlıdur (misafir, genel, kullanıcı, yönetici, site yöneticisi). Yapılandırılmıştan daha yüksek statüye sahip bir kullanıcı(ekleme , silme) eylemlerini yapabilir.</p>
+<p>Kullanıcılar formu göndermeden önce eklemiş oldukları ilgili etileti silebilirler.</p>
Index: extensions/user_tags/language/tr_TR/index.php
===================================================================
--- extensions/user_tags/language/tr_TR/index.php	(revision 12837)
+++ extensions/user_tags/language/tr_TR/index.php	(revision 12837)
@@ -0,0 +1,28 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | User Tags  - a plugin for Piwigo                                      |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010 Nicolas Roudaire             http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA.                                                    |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
Index: extensions/user_tags/language/tr_TR/plugin.lang.php
===================================================================
--- extensions/user_tags/language/tr_TR/plugin.lang.php	(revision 12837)
+++ extensions/user_tags/language/tr_TR/plugin.lang.php	(revision 12837)
@@ -0,0 +1,39 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | User Tags  - a plugin for Piwigo                                      |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2010-2011 Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,            |
+// | MA 02110-1301 USA.                                                    |
+// +-----------------------------------------------------------------------+
+
+// admin
+$lang['Add permission updated'] = 'İzin ekleme güncellendi';
+$lang['Be careful, whatever the configuration value is, new tag can be deleted anyway'] = 'Dikkatli olun, Yapılandırma değeri ne olursa olsun, yeni etiket silinebilir';
+$lang['Delete permission updated'] = 'İzin kaldırma güncellendi';
+$lang['That plugin allow visitors to add tags to image.'] = 'Ziyaretçilerin resimler için etiket eklemesine izin veren bir eklenti';
+$lang['Who can add tags?'] = 'Kim etiket ekleyebilir';
+$lang['Who can delete related tags?'] = 'Kim etiket silebilir';
+$lang['You can choose which users (per status) can add and delete tags.'] = 'Kimler (kullanıcı) etiket ekleyebilir ve silebilir';
+
+// public
+$lang['Click to add tags'] = 'Etiket eklemek için tıklayın';
+$lang['Start to type'] = 'Etiketi yazınız';
+$lang['Tags updated'] = 'Etiketler güncellendi';
+$lang['Update tags'] = 'Etiketleri güncelle';
+$lang['You are not allowed to add nor delete tags'] = 'Etiket eklemek ve silmek için izininiz yok';
+$lang['You are not allowed to add tags'] = 'Etiket eklemek için izininiz yok';
+$lang['You are not allowed to delete tags'] = 'Etiket silmek için izininiz yok';
+?>